;; LispRestart.lsp
;; Demo functions for mulitple callbacks with neobook
;; Hans-Peter Wickern
;; 1.03 11.12.2003
;; This function is called 3 times from the interface DLL,
;; because a new return-string is used in the first 2 returns.
;; The interface pulls commands from newlisp as long as the
;; string 'nlrestart ' is at the beginning of the ruturn-string.
;; Many other Lisp-technics can be used to cut large action-sequences
;; into pieces, so the action can start at once in neobook.
;; 1.04 13.12.2003
;; Now with multirun where each function can set the following functioncall


(context 'Restart)

(define (run )
 (cond
  ((= Restart:count 0)
  (set	'nbActionStr "nlrestart "
	'nbActionStr (append nbActionStr "AlertBox \"Test\" \"This is a 1.Call Action!\"\n")
  )
  (inc Restart:count)				;Remove quote for newLISP 10 (9.9.92)
;  (silent(print nbActionStr))
  nbActionStr
  )
  ((= Restart:count 1)
  (set	'nbActionStr "nlrestart "
	'nbActionStr (append nbActionStr "AlertBox \"Test\" \"This is a 2.Call Action!\"\n")
  )
  (inc Restart:count)				;Remove quote for newLISP 10 (9.9.92)
;  (silent(print nbActionStr))
  nbActionStr
  )
  ((= Restart:count 2)
  (set	'nbActionStr "nb-action "
	'nbActionStr (append nbActionStr "AlertBox \"Test\" \"This is a 3.Call Action!\"\n")
  )
  (inc Restart:count)				;Remove quote for newLISP 10 (9.9.92)
;  (silent(print nbActionStr))
  nbActionStr
  )
 )
)

(define (multirun1 )
  (set	'nbActionStr "nlrestart "
	'nbActionStr (append nbActionStr "AlertBox \"Test\" \"This is a 1.Multi Action!\"\n")
	'nbActionStr (append nbActionStr "setvar \"[nbNewLispRestartCall]\" \"(Restart:multirun2)\"\n")
  )
;  (silent(print nbActionStr))
  nbActionStr
)

(define (multirun2 )
  (set	'nbActionStr "nlrestart "
	'nbActionStr (append nbActionStr "AlertBox \"Test\" \"This is a 2.Multi Action!\"\n")
	'nbActionStr (append nbActionStr "setvar \"[nbNewLispRestartCall]\" \"(Restart:multirun3)\"\n")
;	'nbActionStr (append nbActionStr "setvar \"[nbNewLispRestartCall]\" \"(foo)\"\n")	;To test error handling in multirun
  )
;  (silent(print nbActionStr))
  nbActionStr
)

(define (multirun3 )
  (set	'nbActionStr "nb-action "
	'nbActionStr (append nbActionStr "AlertBox \"Test\" \"This is a 3.Multi Action!\"\n")
  )
;  (silent(print nbActionStr))
  nbActionStr
)

(context 'Restart)

