;; init.lsp
;; Is loaded on newlisp startup
;; Usefull functions for interfacing newLISP with neobook
;; Hans-Peter Wickern
;; 14.12.2003
;; Licensetopic: http://newlispfanclub.alh.net/forum/viewtopic.php?f=2&t=3903&p=19385

;(write-file "myfile.enc" (encrypt "this is a test" "boof boof"))

;(encrypt (read-file "myfile.enc") "boof boof")


(define (repstr str num    newstr)
	(setq newstr "")(dotimes(x num)(setq newstr(append newstr str))))

;(define (allocate n)
;	(join(map (fn (x) " ")(sequence 1 n))))

;From Nigel from the forum (now autoregistered from plugin)
;(define (allocate n)
;	(pack(string "s" n)" "))


(define (repchr n char-index)
	(join(map char(series char-index 1 n))))

;From Nigel Brown newlisp forum
;(define (expander c , z)
;	(begin (setq z '()) (dolist (xx c) (setq z (append z (expandit xx)))) z))
;(define (expandit x)
;	(if (list? (first x)) (map (lambda (y) (append (list y) (rest x))) (first x)) (list x)))
;(define-macro (mcase _x) (eval (append (list 'case _x) (expander (rest (args))))))
;Revised Sam Cox newlisp forum
(define (expander c)
	(apply append (map expandit c)))
(define (expandit x)
	(if (list? (first x))
		;((a b c) d e) --> ((a d e) (b d e) (c d e))
		(map(lambda(y)(append(list y)(rest x)))(first x))
		;else
		;(a d e) --> ((a d e))
		(list x)))
(define-macro (ncase _x)
	(eval(append(list 'case _x)(apply append(map expandit(rest (args)))))))



;function to convert simple list to neobook-list
(define (nl2nb-list nl_lst    item ret_str)
	(setq ret_str "")
	(dolist (item nl_lst)
		(if (string? item)
		(setq ret_str(append ret_str item (char 13)(char 10)))
		(setq ret_str(append ret_str (eval item)(char 13)(char 10)))
		)
		)
	(silent(print ret_str)))


(define (show-tree dir)
	(dolist (nde (directory dir))
		(if (and (directory? (append dir "/" nde)) (!= nde ".") (!= nde ".."))
			(show-tree (append dir "/" nde))
			(println (append dir "/" nde))
		)))

;(show-tree "/usr")    ; on Linux/UNIX
;(show-tree "/")
;(show-tree "c:\\") ;; works ~ on Win32
;(show-tree "c:/") ;; also works on Win32






;customized error-handler (by Lutz from the Forum)
;(define (error-handler) (print "ErrorNum: " (error-number) " " (error-text)))
;set it as the error-event
;(error-event 'error-handler)

(setq nlLoadReturn "init.lsp loaded!")


;(import "user32.dll" "MessageBoxA")
;(MessageBoxA 0 (string "Init.lsp: Loaded") "Test hpwNewLisp" 1)

